<template>
  <div>
    <q-field
      color="blue-12"
      :dense="dense"
      :filled="filled"
      :label="label"
      stack-label
      @click="modal = true"
      :hide-bottom-space="hideBottomSpace"
      :error-message="errorMessage"
      :error="error"
      :loading="loading"
    >
      <template v-slot:prepend>
        <q-icon name="person" />
      </template>

      <!--    @update:model-value="updateValue($event.target.value)"-->
      <template v-slot:after>
        <q-btn
          square
          color="primary"
          icon="person_search"
          @click="modal = true"
        />
      </template>
      <template v-slot:control>
        <div class="self-center full-width no-outline" tabindex="0">
          {{ internalValue }}
        </div>
      </template>
    </q-field>

    <!-- MODAL -->
    <q-dialog v-model="modal">
      <q-card style="width: 900px; max-width: 80vw">
        <q-card-section>
          <div class="text-h6">Busqueda de Persona</div>
        </q-card-section>

        <q-card-section>
          <div class="q-gutter-md">
            <q-banner inline-actions rounded class="bg-blue text-white">
              A tener en cuenta Si la persona esta afiliada en otro organismo,
              solo podra buscar por documento
            </q-banner>
            <div class="row q-col-gutter-sm">
              <div class="col-9">
                <q-input
                  v-model="form.query"
                  dense
                  color="purple-12"
                  label="Ingrese un Dni o un nombre"
                >
                </q-input>
              </div>
              <div class="col-3">
                <q-btn
                  class="full-width"
                  label="Buscar"
                  color="green"
                  @click.prevent="personaBuscar()"
                />
              </div>
            </div>
          </div>
          <Loading :showing="loading" />
        </q-card-section>
        <q-card-section class="q-pt-none">
          <q-list bordered separator>
            <q-item
              clickable
              v-ripple
              v-for="persona in dataSet"
              :key="persona.uuid"
              @click="personaSeleccionar(persona)"
            >
              <q-item-section>
                <PersonaDetalle :persona="persona" />
              </q-item-section>
              <q-item-section side>Seleccionar</q-item-section>
            </q-item>
          </q-list>
        </q-card-section>
      </q-card>
    </q-dialog>
  </div>
</template>

<script lang="ts">
import {
  defineComponent,
  PropType,
  ref,
  reactive,
  onMounted,
  watch,
} from 'vue';
import { api } from 'src/boot/axios/index';
import PersonaDetalle from 'components/Personas/Detalle.vue';
import { PersonaBasicaInterface } from 'src/interfaces/PersonasInterface';
import { useQuasar } from 'quasar';
import { AxiosResponse } from 'axios';
import Loading from 'src/components/Loading.vue';
interface Form {
  query: string;
  tipo: string;
  afiliado: string;
}

export default defineComponent({
  props: {
    modelValue: {
      type: String as PropType<string>,
      default: '',
    },

    label: {
      type: String as PropType<string>,
      required: false,
      default: 'Buscar por Dni o Nombre',
    },

    dense: {
      type: Boolean as PropType<boolean>,
      required: false,
      default: true,
    },

    filled: {
      type: Boolean as PropType<boolean>,
      required: false,
      default: true,
    },

    tipo: {
      // SI acepta adultos o beneficiarios o todo
      type: String,
      required: false,
      default: 'A',
    },
    afiliado: {
      // miembros o ex miembros
      type: String,
      required: false,
      default: 'S',
    },
    error: {
      type: Boolean as PropType<boolean>,
      required: false,
      default: false,
    },
    errorMessage: {
      type: String as PropType<string>,
      required: false,
    },
    hideBottomSpace: {
      type: Boolean as PropType<boolean>,
      required: false,
      default: false,
    },
  },
  components: {
    Loading,
    PersonaDetalle,
  },

  setup(props, { emit }) {
    const $q = useQuasar();
    const internalValue = ref(props.modelValue);
    const modal = ref(false);
    const loading = ref(false);
    const form = reactive<Form>({
      query: '',
      tipo: props.tipo,
      afiliado: props.afiliado,
    });

    //
    onMounted(() => {
      // el componente recive como parametro el UUID de una persona, pero debe mostrar el nombre.
      obtenerNombre();
    });

    function obtenerNombre() {
      if (
        internalValue.value === '' ||
        internalValue.value === undefined ||
        internalValue.value === null
      ) {
        return;
      }
      loading.value = true;

      api
        .get('/api/persona/personas/get_nombre/' + internalValue.value)
        .then((response: AxiosResponse) => {
          internalValue.value = response.data;
        })
        .finally(() => (loading.value = false));
    }

    const dataSet = ref<PersonaBasicaInterface[]>([]);
    function personaBuscar() {
      loading.value = true;
      dataSet.value = [];

      if (form.query === '') {
        loading.value = false;
        $q.notify({
          message: 'Debe definir un valor de busqueda',
          position: 'top',
          color: 'red',
        });
        return;
      }
      $q.notify({
        spinner: true,
        message: 'Procesando busqueda ...',
        timeout: 2000,
      });
      api
        .get('/api/persona/personas/busqueda/basica', {
          params: form,
        })
        .then((response: AxiosResponse) => {
          dataSet.value = response.data.data;
          loading.value = false;
        });
    }

    // el watch es imporante por si se crea el componente y depues se asigna un valor al model, si no este componente no detecta el cambio
    //  const modelValueTemp = ref(props.modelValue); //<--- podria pasar el props.modelValue directo al watch y funciona, pero el vcode da error de codigo
    /*.
    watch(props.modelValue, (newValue: string) => {
      console.log('HOLA MUNDO', props.modelValue);
      internalValue.value = newValue;
      obtenerNombre();
    });*/

    watch(
      () => props.modelValue,
      (newValue: string) => {
        internalValue.value = newValue;
        obtenerNombre();
      }
    );

    function personaSeleccionar(valor: PersonaBasicaInterface) {
      internalValue.value = valor.apellidoynombre; // en el campo muestro el apellido ..
      emit('update:modelValue', valor.uuid); // al model padre devuelvo el UUID
      modal.value = false; // cierro el modal
    }

    return {
      internalValue,
      //  updateValue,
      form,
      loading,
      modal,
      dataSet,
      personaBuscar,
      personaSeleccionar,
    };
  },
});
</script>
